/*
 * Wazuh report dispatcher mock
 * Copyright (C) 2015, Wazuh Inc.
 * March 9, 2024.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */
#ifndef _MOCK_REPORT_DISPATCHER_HPP
#define _MOCK_REPORT_DISPATCHER_HPP

#include "gmock/gmock.h"
#include "gtest/gtest.h"

#include "json.hpp"

/**
 * @class MockReportDispatcher
 *
 * @brief Mock class for simulating a report dispatcher object.
 *
 */
class MockReportDispatcher
{
public:
    /**
     * @brief Mock Constructor
     *
     * @note This method is intended for testing purposes and does not perform any real action.
     */
    MockReportDispatcher() = default;

    /**
     * @brief Mock Constructor
     *
     * @note This method is intended for testing purposes and does not perform any real action.
     */
    explicit MockReportDispatcher(const std::string&) {};

    virtual ~MockReportDispatcher() = default;

    /**
     * @brief Mock method for query.
     *
     * @note This method is intended for testing purposes and does not perform any real action.
     */
    MOCK_METHOD(void, push, (const std::string&), ());
};

#endif // _MOCK_REPORT_DISPATCHER_HPP
