/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * February 21, 2024.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _CLEAN_UP_DATA_HPP
#define _CLEAN_UP_DATA_HPP

#include "rocksDBWrapper.hpp"
#include "scanOrchestrator.hpp"
#include "gtest/gtest.h"

/**
 * @brief CleanAgentInventory test class.
 */
class CleanAgentInventoryTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    CleanAgentInventoryTest() = default;
    ~CleanAgentInventoryTest() override = default;

    /**
     * @brief Set up for every test.
     *
     */
    void SetUp() override;

    /**
     * @brief Tear down for every test.
     *
     */
    void TearDown() override;

    /**
     * @brief RocksDB inventory database.
     *
     */
    std::unique_ptr<Utils::RocksDBWrapper> m_inventoryDatabase;
    // LCOV_EXCL_STOP
};

#endif // _CLEAN_UP_DATA_HPP
