/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * November 8, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _CVE_5_FB_TEST_HPP
#define _CVE_5_FB_TEST_HPP

#include "gtest/gtest.h"

/**
 * @brief Tests for the CVE5 flatbuffer schema.
 *
 * @details The schema should be able to parse CVEv5 documents (full or partial) and fail gracefully when the document
 * is invalid.
 */
class Cve5FbTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    Cve5FbTest() = default;
    ~Cve5FbTest() override = default;
    // LCOV_EXCL_STOP
};

#endif //_CVE_5_FB_TEST_H
