/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * September 21, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _PACKAGE_SCANNER_TEST_HPP
#define _PACKAGE_SCANNER_TEST_HPP

#include "gtest/gtest.h"

/**
 * @brief Runs unit tests for PackageScanner
 */
class PackageScannerTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    PackageScannerTest() = default;
    ~PackageScannerTest() override = default;

    /**
     * @brief Set the environment for testing.
     *
     */
    void SetUp() override;

    /**
     * @brief Clean the environment after testing.
     *
     */
    void TearDown() override;
    // LCOV_EXCL_STOP
};

#endif // _PACKAGE_SCANNER_TEST_HPP
