/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * February 21, 2024.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _SCAN_AGENT_LIST_TEST_HPP
#define _SCAN_AGENT_LIST_TEST_HPP

// databaseFeedManager.hpp should be included before its mock due to
// the declaración of FlatbufferDataPair.
#include "databaseFeedManager.hpp"
#include "socketServer.hpp"
#include "gtest/gtest.h"

/**
 * @brief ScanAgentList test class.
 *
 */
class ScanAgentListTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    ScanAgentListTest() = default;
    ~ScanAgentListTest() override = default;

    /**
     * @brief Set the environment for testing.
     *
     */
    void SetUp() override {}

    /**
     * @brief Clean the environment after testing.
     *
     */
    void TearDown() override {}

    /**
     * @brief RocksDB inventory database.
     *
     */
    std::unique_ptr<Utils::RocksDBWrapper> m_inventoryDatabase;
    // LCOV_EXCL_STOP
};

#endif // _SCAN_AGENT_LIST_TEST_HPP
