/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * March 5, 2024.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _SCAN_OS_ALERT_DETAILS_BUILDER_TEST_HPP
#define _SCAN_OS_ALERT_DETAILS_BUILDER_TEST_HPP

#include "policyManager.hpp"
#include "socketServer.hpp"
#include "gtest/gtest.h"
#include <filesystem>

/**
 * @brief Runs unit tests for ScanOsAlertDetailsBuilder.
 *
 */
class ScanOsAlertDetailsBuilderTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    ScanOsAlertDetailsBuilderTest() = default;
    ~ScanOsAlertDetailsBuilderTest() override = default;

    /**
     * @brief Set the environment for testing.
     *
     */
    void SetUp() override;

    /**
     * @brief Clean the environment after testing.
     *
     */
    void TearDown() override;
    // LCOV_EXCL_STOP
};

#endif // _SCAN_OS_ALERT_DETAILS_BUILDER_TEST_HPP
