/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * October 3, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _UPDATE_CVE_DESCRIPTION_TEST_HPP
#define _UPDATE_CVE_DESCRIPTION_TEST_HPP

#include "gtest/gtest.h"
#include <filesystem>

const std::string DATABASE_DIR {"queue/vd"};

/**
 * @brief UpdateCVEDescription test class.
 */
class UpdateCVEDescriptionTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    UpdateCVEDescriptionTest() = default;
    ~UpdateCVEDescriptionTest() override = default;
    // LCOV_EXCL_STOP

    /**
     * @brief SetUp Test Suite.
     *
     */
    static void SetUpTestSuite()
    {
        // Create rocksDB base directory.
        std::filesystem::create_directories(DATABASE_DIR);
    }

    /**
     * @brief TearDown Test Suite.
     *
     */
    static void TearDownTestSuite()
    {
        // Remove directory
        std::filesystem::remove_all("queue");
    }
};

#endif // _UPDATE_CVE_DESCRIPTION_TEST_HPP
