/*
 * Wazuh databaseFeedManager
 * Copyright (C) 2015, Wazuh Inc.
 * November 2, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */
#ifndef _VERSION_MATCHER_TEST_HPP
#define _VERSION_MATCHER_TEST_HPP
#include "versionMatcher/versionMatcher.hpp"
#include "gmock/gmock.h"
#include "gtest/gtest.h"

/**
 * @brief This test class contains unit tests for the databaseFeedManager module.
 */
class VersionMatcherTest : public ::testing::Test
{
protected:
    /**
     * @brief Construct a new Database Feed Manager Tests object
     *
     */
    VersionMatcherTest() = default;

    /**
     * @brief Destroy the Database Feed Manager Tests object
     *
     */
    virtual ~VersionMatcherTest() = default;

    /**
     * @brief SetUp.
     *
     */
    void SetUp() override;

    /**
     * @brief TearDown.
     *
     */
    void TearDown() override;
};

#endif //_VERSION_MATCHER_TEST_HPP
